import sys
import os
import shutil
from quickweb.template_maker import TemplateMaker
from os.path import exists


def init(app_directory, template_directory, force):
    print("Creating app on directory", app_directory)
    if exists(app_directory):
        if force:
            shutil.rmtree(app_directory)
        else:
            sys.stderr.write(app_directory + ' already exists!\n')
            sys.exit(2)
    shutil.copytree(template_directory, app_directory)


def make_template(template_url, template_directory):
    TemplateMaker(template_url, template_directory).make()


def run(app_directory):
    from quickweb import wsgiserver
    wsgiserver.run(app_directory)

def git_init(app_directory, git_url, force):
    os.chdir(app_directory)
    if exists('.git') and not force:
        sys.stderr.write("Git is already setup for this application.\n")
        sys.exit(2)

    os.system('git init')
    os.system('git add . ')
    os.system('git commit -m "First commit"')
    os.system('git remote add origin '+git_url)
    os.system('git remote -v')
    os.system('git push origin master --force')


