import imp
from os.path import join, basename
import os

def start_simple_server(app_directory):
    fwtype = "wsgiref"
    for fw in ("cherrypy"):
        try:
            imp.find_module(fw)
            fwtype = fw
        except ImportError:
            pass

    ip = 'localhost'
    port = 8080
    print('Starting WSGIServer type %s on http://%s:%d ... ' % (fwtype, ip, port))
    from wsgiref.simple_server import make_server
    import quickweb.wsgi.application as application
    application.setup_app(basename(app_directory), join(os.getcwd(), app_directory))
    make_server(ip, port, application.app).serve_forever()

def run(app_directory):

    if app_directory:  # Running from with "quickweb run"
        start_simple_server(app_directory)
        return


    ip = os.environ.get('OPENSHIFT_PYTHON_IP', '127.0.0.1')
    port = int(os.environ.get('OPENSHIFT_PYTHON_PORT', 9090))

    app = imp.load_source('application', join(current_dir, 'wsgi', 'application.py'))

    fwtype = "wsgiref"
    for fw in ("cherrypy"):
        try:
            imp.find_module(fw)
            fwtype = fw
        except ImportError:
            pass

    print('Starting WSGIServer type %s on %s:%d ... ' % (fwtype, ip, port))
    if fwtype == "cherrypy":
        from cherrypy import wsgiserver

        server = wsgiserver.CherryPyWSGIServer(
            (ip, port), app, server_name=os.environ.get('OPENSHIFT_APP_DNS', 'localhost'))
        server.start()
    else:
        from wsgiref.simple_server import make_server
        make_server(ip, port, app.application).serve_forever()